package yrpg.bamp.basedata.plugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

/**
 * 单据界面插件
 * 费用承担部门F7过滤通用插件
 */
public class DepartmentFilterBillPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        String formId = this.getModel().getDataEntityType().toString();
        DynamicObject baseData = BusinessDataServiceHelper.loadSingle("yrpg_expensefilt", new QFilter[]{new QFilter("number", QCP.equals, formId)});
        if (baseData!=null){
            String depIdentifying = baseData.getString("yrpg_department");

            BasedataEdit basedataEdit=this.getControl(depIdentifying);
            basedataEdit.addBeforeF7SelectListener(this);

        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String formId = this.getModel().getDataEntityType().toString();
        DynamicObject baseData = BusinessDataServiceHelper.loadSingle("yrpg_expensefilt", new QFilter[]{new QFilter("number", QCP.equals, formId)});
        if (baseData!=null){
            String depIdentifying = baseData.getString("yrpg_department");
            String comIdentifying = baseData.getString("yrpg_company");
            boolean ifcomhead = baseData.getBoolean("yrpg_ifcompanyhead");
            boolean ifdephead = baseData.getBoolean("yrpg_ifdepartmenthead");
            if (comIdentifying.equals(e.getProperty().getName())){
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                if (ifcomhead&&ifdephead){
                    dataEntity.set(depIdentifying,null);
                }else if (ifcomhead&&!ifdephead){
                    String entryIdentifying = baseData.getString("yrpg_entry");
                    DynamicObjectCollection entryEntity = this.getModel().getEntryEntity(entryIdentifying);
                    for (DynamicObject row : entryEntity) {
                        row.set(depIdentifying,null);
                    }
                }else if (!ifcomhead&&!ifdephead){
                    String entryIdentifying = baseData.getString("yrpg_entry");
                    int index = this.getModel().getEntryCurrentRowIndex(entryIdentifying);
                    DynamicObjectCollection entryEntity = this.getModel().getEntryEntity(entryIdentifying);
                    for (DynamicObject row : entryEntity) {
                        if (index== row.getInt("seq")-1){
                            row.set(depIdentifying,null);
                        }
                    }
                }

                this.getView().updateView();
            }
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {
        String fieldName = beforeF7SelectEvent.getProperty().getName();

        String formId = this.getModel().getDataEntityType().toString();
        DynamicObject baseData = BusinessDataServiceHelper.loadSingle("yrpg_expensefilt", new QFilter[]{new QFilter("number", QCP.equals, formId)});
        if (baseData!=null){
            String depIdentifying = baseData.getString("yrpg_department");
            String comIdentifying = baseData.getString("yrpg_company");
            boolean ifcomhead = baseData.getBoolean("yrpg_ifcompanyhead");
            boolean ifdephead = baseData.getBoolean("yrpg_ifdepartmenthead");
            if (depIdentifying.equals(fieldName)){
                if (ifcomhead&&ifdephead){
                    //公司部门都在表头
                    DynamicObject company = (DynamicObject) this.getModel().getValue(comIdentifying);
                    if (company!=null){
                        String companyLongName="";
                        DynamicObjectCollection structure = company.getDynamicObjectCollection("structure");
                        for (DynamicObject dynamicObject : structure) {
                            companyLongName=dynamicObject.getString("fullname");
                            break;
                        }
                        QFilter qFilter = new QFilter("structure.fullname", QCP.like, "%"+companyLongName+"%");
                        ListShowParameter showParameter = (ListShowParameter) beforeF7SelectEvent.getFormShowParameter();
                        showParameter.getListFilterParameter().setFilter(qFilter);
                    }
                }else if (ifcomhead&&!ifdephead){
                    //公司表头、部门表体
                    DynamicObject company = (DynamicObject) this.getModel().getValue(comIdentifying);
                    if (company!=null){
                        String companyLongName="";
                        DynamicObjectCollection structure = company.getDynamicObjectCollection("structure");
                        for (DynamicObject dynamicObject : structure) {
                            companyLongName=dynamicObject.getString("fullname");
                            break;
                        }
                        QFilter qFilter = new QFilter("structure.fullname", QCP.like, "%"+companyLongName+"%");
                        ListShowParameter showParameter = (ListShowParameter) beforeF7SelectEvent.getFormShowParameter();
                        showParameter.getListFilterParameter().setFilter(qFilter);
                    }



                }else if (!ifcomhead&&!ifdephead){
                    //公司部门都在表体
                    String entryIdentifying = baseData.getString("yrpg_entry");
                    int index = this.getModel().getEntryCurrentRowIndex(entryIdentifying);
                    DynamicObject company = (DynamicObject)this.getModel().getValue(comIdentifying, index);
                    if (company!=null){
                        String companyLongName="";
                        DynamicObjectCollection structure = company.getDynamicObjectCollection("structure");
                        for (DynamicObject dynamicObject : structure) {
                            companyLongName=dynamicObject.getString("fullname");
                            break;
                        }
                        QFilter qFilter = new QFilter("structure.fullname", QCP.like, "%"+companyLongName+"%");
                        ListShowParameter showParameter = (ListShowParameter) beforeF7SelectEvent.getFormShowParameter();
                        showParameter.getListFilterParameter().setFilter(qFilter);
                    }
                }
            }

        }
    }


}