package yrpg.bamp.basedata.plugin.operate;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.sdk.plugin.Plugin;
import yrpg.bamp.basedata.plugin.util.ExpenseItemApiUtil;

import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Map;

/**
 * 单据操作插件
 * 同步费用项目至MDM
 */
public class PushExpenseItemToMDMOpPlugin extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        e.getFieldKeys().add("number");
        e.getFieldKeys().add("name");
        e.getFieldKeys().add("level");
        e.getFieldKeys().add("isleaf");
        e.getFieldKeys().add("ctrlstrategy");
        e.getFieldKeys().add("offset");
        e.getFieldKeys().add("reimburseamountctlmethod");
        e.getFieldKeys().add("relbilltype");
        e.getFieldKeys().add("taxrate");
        e.getFieldKeys().add("reimctltype");
        e.getFieldKeys().add("reimbursediscription");
        e.getFieldKeys().add("noinvoice");
        e.getFieldKeys().add("isreimburseamountctl");
        e.getFieldKeys().add("remark");
        e.getFieldKeys().add("parent");
        e.getFieldKeys().add("creator");
        e.getFieldKeys().add("modifier");
        e.getFieldKeys().add("createorg");
        e.getFieldKeys().add("org");
        e.getFieldKeys().add("useorg");
    }



    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        //组装报文
        JSONObject dataJson = new JSONObject();
        JSONArray dataArray = new JSONArray();
        for (DynamicObject dataEntity : e.getDataEntities()) {
            JSONObject simpleDataJsonObject = new JSONObject();
            String id = dataEntity.getString("id");
            String number = dataEntity.getString("number");
            String name = dataEntity.getString("name");
            String level = dataEntity.getString("level");
            String isleaf = dataEntity.getBoolean("isleaf")?"Y":"N";
            String ctrlstrategy = dataEntity.getString("ctrlstrategy");
            String offset = dataEntity.getBoolean("offset")?"Y":"N";
            String reimburseamountctlmethod = dataEntity.getString("reimburseamountctlmethod");
            String relbilltype = dataEntity.getString("relbilltype");
            String taxrate = dataEntity.getBigDecimal("taxrate").toString();
            String reimctltype = dataEntity.getString("reimctltype");
            String reimbursediscription = dataEntity.getString("reimbursediscription");
            String noinvoice = dataEntity.getBoolean("noinvoice")?"Y":"N";
            String isreimburseamountctl = dataEntity.getString("isreimburseamountctl");
            String remark = dataEntity.getString("remark");
            String creator_number = dataEntity.getDynamicObject("creator").getString("number");
            String creator_name = dataEntity.getDynamicObject("creator").getString("name");
            String modifier_number = dataEntity.getDynamicObject("modifier").getString("number");
            String modifier_name = dataEntity.getDynamicObject("modifier").getString("name");
            String createorg_name = dataEntity.getDynamicObject("createorg").getString("yrpg_companynum");
            String org_name = dataEntity.getDynamicObject("org").getString("yrpg_companynum");
//            String useorg_name = dataEntity.getDynamicObject("useorg").getString("name");
            String useorg_name = dataEntity.getDynamicObject("useorg")==null?"":dataEntity.getDynamicObject("useorg").getString("yrpg_companynum");




            simpleDataJsonObject.put("id",id);
            simpleDataJsonObject.put("code",number);
            simpleDataJsonObject.put("name",name);
            simpleDataJsonObject.put("level1",level);
            simpleDataJsonObject.put("isleaf#code",isleaf);
            simpleDataJsonObject.put("ctrlstrategy#code",ctrlstrategy);
            simpleDataJsonObject.put("offset1#code",offset);
            simpleDataJsonObject.put("reimburseamountctl#code",reimburseamountctlmethod);
            simpleDataJsonObject.put("relbill_type",relbilltype);
            simpleDataJsonObject.put("taxrate",taxrate);
            simpleDataJsonObject.put("reimctltype#code",reimctltype);
            simpleDataJsonObject.put("reimburse",reimbursediscription);
            simpleDataJsonObject.put("noinvoice#code",noinvoice);
            simpleDataJsonObject.put("isreimbursea#code",isreimburseamountctl);
            simpleDataJsonObject.put("remark",remark);
            simpleDataJsonObject.put("creator_number",creator_number);
            simpleDataJsonObject.put("creator_name",creator_name);
            simpleDataJsonObject.put("modifier_number",modifier_number);
            simpleDataJsonObject.put("modifier_name",modifier_name);
            simpleDataJsonObject.put("createorg_name#code",createorg_name);
            simpleDataJsonObject.put("org_name#code",org_name);
            simpleDataJsonObject.put("useorg_name#code",useorg_name);

            DynamicObject parent = dataEntity.getDynamicObject("parent");
            if (parent!=null){
                String parent_number = parent.getString("number");
                String parent_status = "";
                switch (parent.getString("status")){
                    case "A":
                        parent_status="暂存";
                        break;
                    case "B":
                        parent_status="已提交";
                        break;
                    case "C":
                        parent_status="已审核";
                        break;
                }
                String parent_enable = "0".equals(parent.getString("enable"))?"禁用":"可用";
                SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                String parent_createtime = formatter.format(parent.getDate("createtime"));
                String parent_modifytime = formatter.format(parent.getDate("modifytime"));
                String parent_level = parent.getString("level");
                String parent_ctrlstrategy = parent.getString("ctrlstrategy");
                String parent_isleaf = parent.getBoolean("isleaf")?"Y":"N";





                simpleDataJsonObject.put("parent_number#code",parent_number);
                simpleDataJsonObject.put("parent_status",parent_status);
                simpleDataJsonObject.put("parent_enable",parent_enable);
                simpleDataJsonObject.put("parent_createtime",parent_createtime);
                simpleDataJsonObject.put("parent_modifytime",parent_modifytime);
                simpleDataJsonObject.put("parent_level",parent_level);
                simpleDataJsonObject.put("parent_ctrlstrategy#code",parent_ctrlstrategy);
                simpleDataJsonObject.put("parent_isleaf#code",parent_isleaf);
            }


            simpleDataJsonObject.put("enablestate#name","启用");





            dataArray.add(simpleDataJsonObject);
        }


        dataJson.put("masterData",dataArray);

        String param=dataJson.toString();
        String url=System.getProperty("yrpg.bamp.basedata.expenseitem.url");
        String result = ExpenseItemApiUtil.getHttp(param, url);

        //记录日志
        Map<String, Object> logMap = new HashMap<>();
        logMap.put("opname", "ExpenseItem");
        logMap.put("opdesc", url);
        logMap.put("request", param);
        logMap.put("response", result);
        logMap.put("thirdappname", "MDM");
        logMap.put("status", "true");
        ExpenseItemApiUtil.saveApiLog(logMap);
    }
}