package yrpg.bamp.basedata.webapi.pojo;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

@ApiModel
public class CustomerDTO {

    @ApiParam(value = "编码", required = true, message = "客户编码不能为空")
    private String number;
    @ApiParam(value = "名称", required = true, message = "客户名称不能为空")
    private String name;
    @ApiParam(value = "客户类型", required = true, message = "客户类型不能为空")
    private String customer_class;
    @ApiParam(value = "省份名称")
    private String province;
    @ApiParam(value = "城市名称")
    private String city;
    @ApiParam(value = "区县名称")
    private String district;
    @ApiParam(value = "曾用名")
    private String previous_name;
    @ApiParam(value = "经度")
    private String longitude;
    @ApiParam(value = "纬度")
    private String latitude;
    @ApiParam(value = "统一社会信用代码")
    private String uscc;
    @ApiParam(value = "经营许可证登记号")
    private String business_reg_number;
    @ApiParam(value = "经营范围")
    private String business_scope;
    @ApiParam(value = "营业期限")
    private String business_term;
    @ApiParam(value = "法定代表人")
    private String artificial_person;
    @ApiParam(value = "工商登记状态")
    private String register_status;
    @ApiParam(value = "电话")
    private String phone;
    @ApiParam(value = "是否医保医院(门店)")
    private String is_insurance;
    @ApiParam(value = "是否分院")
    private String is_branch;
    @ApiParam(value = "医院组合名称")
    private String hospital_coname;
    @ApiParam(value = "客户等级")
    private String customer_level;
    @ApiParam(value = "客户等别")
    private String customer_grade;
    @ApiParam(value = "医保编码")
    private String medicare_code;
    @ApiParam(value = "医院类型")
    private String hospital_type;
    @ApiParam(value = "盈利类型")
    private String profit_type;
    @ApiParam(value = "是否医联体")
    private String is_medical_joined;
    @ApiParam(value = "是否民营医疗集团")
    private String is_private_medicalgroup;
    @ApiParam(value = "经营方式")
    private String operate_mode;
    @ApiParam(value = "药店属性")
    private String pharmacy_attribute;
    @ApiParam(value = "商圈类型")
    private String business_distinct_type;
    @ApiParam(value = "地域属性")
    private String region_attribute;
    @ApiParam(value = "是否为o2o店")
    private String is_o2o_store;
    @ApiParam(value = "是否医保双通道")
    private String is_double_insurance;
    @ApiParam(value = "是否DTP药房")
    private String is_dtp_store;
    @ApiParam(value = "全品类门店潜力等级")
    private String store_potential;
    @ApiParam(value = "一级分类")
    private String first_class;
    @ApiParam(value = "二级分类")
    private String second_class;
    @ApiParam(value = "三级分类")
    private String third_class;
    @ApiParam(value = "注册地址")
    private String registered_address;
    @ApiParam(value = "收货地址组合名称")
    private String shipping_address;
    @ApiParam(value = "总院行业库id")
    private String general_hospital_id;
    @ApiParam(value = "总院主数据编码")
    private String general_hospital_number;
    @ApiParam(value = "总院名称")
    private String general_hospital_name;
    @ApiParam(value = "行业库id")
    private String industry_id;
    @ApiParam(value = "上级行业库id")
    private String higher_industry_id;
    @ApiParam(value = "上级主数据编码")
    private String master_head_customer_id;
    @ApiParam(value = "上级名称")
    private String higher_name;
    @ApiParam(value = "使用状态", required = true, message = "客户使用状态不能为空")
    private String enable;

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCustomer_class() {
        return customer_class;
    }

    public void setCustomer_class(String customer_class) {
        this.customer_class = customer_class;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getPrevious_name() {
        return previous_name;
    }

    public void setPrevious_name(String previous_name) {
        this.previous_name = previous_name;
    }

    public String getLongitude() {
        return longitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    public String getLatitude() {
        return latitude;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    public String getUscc() {
        return uscc;
    }

    public void setUscc(String uscc) {
        this.uscc = uscc;
    }

    public String getBusiness_reg_number() {
        return business_reg_number;
    }

    public void setBusiness_reg_number(String business_reg_number) {
        this.business_reg_number = business_reg_number;
    }

    public String getBusiness_scope() {
        return business_scope;
    }

    public void setBusiness_scope(String business_scope) {
        this.business_scope = business_scope;
    }

    public String getBusiness_term() {
        return business_term;
    }

    public void setBusiness_term(String business_term) {
        this.business_term = business_term;
    }

    public String getArtificial_person() {
        return artificial_person;
    }

    public void setArtificial_person(String artificial_person) {
        this.artificial_person = artificial_person;
    }

    public String getRegister_status() {
        return register_status;
    }

    public void setRegister_status(String register_status) {
        this.register_status = register_status;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getIs_insurance() {
        return is_insurance;
    }

    public void setIs_insurance(String is_insurance) {
        this.is_insurance = is_insurance;
    }

    public String getIs_branch() {
        return is_branch;
    }

    public void setIs_branch(String is_branch) {
        this.is_branch = is_branch;
    }

    public String getHospital_coname() {
        return hospital_coname;
    }

    public void setHospital_coname(String hospital_coname) {
        this.hospital_coname = hospital_coname;
    }

    public String getCustomer_level() {
        return customer_level;
    }

    public void setCustomer_level(String customer_level) {
        this.customer_level = customer_level;
    }

    public String getCustomer_grade() {
        return customer_grade;
    }

    public void setCustomer_grade(String customer_grade) {
        this.customer_grade = customer_grade;
    }

    public String getMedicare_code() {
        return medicare_code;
    }

    public void setMedicare_code(String medicare_code) {
        this.medicare_code = medicare_code;
    }

    public String getHospital_type() {
        return hospital_type;
    }

    public void setHospital_type(String hospital_type) {
        this.hospital_type = hospital_type;
    }

    public String getProfit_type() {
        return profit_type;
    }

    public void setProfit_type(String profit_type) {
        this.profit_type = profit_type;
    }

    public String getIs_medical_joined() {
        return is_medical_joined;
    }

    public void setIs_medical_joined(String is_medical_joined) {
        this.is_medical_joined = is_medical_joined;
    }

    public String getIs_private_medicalgroup() {
        return is_private_medicalgroup;
    }

    public void setIs_private_medicalgroup(String is_private_medicalgroup) {
        this.is_private_medicalgroup = is_private_medicalgroup;
    }

    public String getOperate_mode() {
        return operate_mode;
    }

    public void setOperate_mode(String operate_mode) {
        this.operate_mode = operate_mode;
    }

    public String getPharmacy_attribute() {
        return pharmacy_attribute;
    }

    public void setPharmacy_attribute(String pharmacy_attribute) {
        this.pharmacy_attribute = pharmacy_attribute;
    }

    public String getBusiness_distinct_type() {
        return business_distinct_type;
    }

    public void setBusiness_distinct_type(String business_distinct_type) {
        this.business_distinct_type = business_distinct_type;
    }

    public String getRegion_attribute() {
        return region_attribute;
    }

    public void setRegion_attribute(String region_attribute) {
        this.region_attribute = region_attribute;
    }

    public String getIs_o2o_store() {
        return is_o2o_store;
    }

    public void setIs_o2o_store(String is_o2o_store) {
        this.is_o2o_store = is_o2o_store;
    }

    public String getIs_double_insurance() {
        return is_double_insurance;
    }

    public void setIs_double_insurance(String is_double_insurance) {
        this.is_double_insurance = is_double_insurance;
    }

    public String getIs_dtp_store() {
        return is_dtp_store;
    }

    public void setIs_dtp_store(String is_dtp_store) {
        this.is_dtp_store = is_dtp_store;
    }

    public String getStore_potential() {
        return store_potential;
    }

    public void setStore_potential(String store_potential) {
        this.store_potential = store_potential;
    }

    public String getFirst_class() {
        return first_class;
    }

    public void setFirst_class(String first_class) {
        this.first_class = first_class;
    }

    public String getSecond_class() {
        return second_class;
    }

    public void setSecond_class(String second_class) {
        this.second_class = second_class;
    }

    public String getThird_class() {
        return third_class;
    }

    public void setThird_class(String third_class) {
        this.third_class = third_class;
    }

    public String getRegistered_address() {
        return registered_address;
    }

    public void setRegistered_address(String registered_address) {
        this.registered_address = registered_address;
    }

    public String getShipping_address() {
        return shipping_address;
    }

    public void setShipping_address(String shipping_address) {
        this.shipping_address = shipping_address;
    }

    public String getGeneral_hospital_id() {
        return general_hospital_id;
    }

    public void setGeneral_hospital_id(String general_hospital_id) {
        this.general_hospital_id = general_hospital_id;
    }

    public String getGeneral_hospital_number() {
        return general_hospital_number;
    }

    public void setGeneral_hospital_number(String general_hospital_number) {
        this.general_hospital_number = general_hospital_number;
    }

    public String getGeneral_hospital_name() {
        return general_hospital_name;
    }

    public void setGeneral_hospital_name(String general_hospital_name) {
        this.general_hospital_name = general_hospital_name;
    }

    public String getIndustry_id() {
        return industry_id;
    }

    public void setIndustry_id(String industry_id) {
        this.industry_id = industry_id;
    }

    public String getHigher_industry_id() {
        return higher_industry_id;
    }

    public void setHigher_industry_id(String higher_industry_id) {
        this.higher_industry_id = higher_industry_id;
    }

    public String getMaster_head_customer_id() {
        return master_head_customer_id;
    }

    public void setMaster_head_customer_id(String master_head_customer_id) {
        this.master_head_customer_id = master_head_customer_id;
    }

    public String getHigher_name() {
        return higher_name;
    }

    public void setHigher_name(String higher_name) {
        this.higher_name = higher_name;
    }

    public String getEnable() {
        return enable;
    }

    public void setEnable(String enable) {
        this.enable = enable;
    }

}
